package Aplpl::PAIR;
use strict;

#use Aplpl::NAME;
use Exporter;
use vars qw(@ISA @EXPORT $nil $null);

@ISA = ("Exporter");
@EXPORT = qw(&make_list &pairp &nullp &cons &nlcons &car &cdr  &isnull 
             &ldisp &llength &set_car &set_cdr $nil $null);

sub make_list {
   my (@args)=@_;
   
   my $head;
   my $tail;

   my $init = sub {
                     $head = pop @args;
                     $tail = $nil;
                     while ($head) {
                        $tail = bless([$head, $tail], 'Aplpl::PAIR');
                        $head = pop @args;
                     }
                     return $tail;
                  };
   $init->();
};

$null = "";
$nil  = bless([$null, $null], 'Aplpl::PAIR');

sub pairp {
   my $arg = shift;
   if (ref($arg) eq "Aplpl::PAIR") {
      return 1;
   }
   else {
      return 0;
   }
};

sub isnull {
   my $obj = shift;
   if ($obj == $null) {
      return 1;
   }
   else {
      return 0;
   }
}

sub nullp {
   my ($ls)=@_;
   if ($ls == $nil) {
      return 1;
   }
   else {
      return 0;
   }
};

sub cons {
   my ($head, $tail)=@_;
   return bless([$head, $tail], 'Aplpl::PAIR');
};

sub nlcons {
   my ($hd, $tl)=@_;
   if ($hd <= Aplpl::NAME::maxName()) {
      return bless([$hd, $tl], 'Aplpl::PAIR');
   }
   else {
      print "nlcons: invalid argument type!<br>\n";
      return $tl;
   }
};

sub car {
   my ($ls)=@_;
   if (pairp($ls)) {
      return $ls->[0];
   }
   else {
      print "ls: " . $ls . "<br>\n";
      print "car: invalid argument!<br>\n";
      return "";
   }
};

sub cdr {
   my ($ls)=@_;
   if (pairp($ls)) {
      my $tl = $ls->[1];
      if ($tl) {
         return $tl;
      }
      else {
         return $nil;
      }
   }
   else {
      print "cdr: invalid argument!\n";
      return "";
   }
};

sub set_car {
   my ($ls, $obj)=@_;
   $ls->[0] = $obj;
   return $ls;
};

sub set_cdr {
   my ($ls, $obj)=@_;
   $ls->[1] = $obj;
   return $ls;
};

sub llength {
   my ($ls)=@_;
   my $cnt = 0;
   while ($ls) {
      if ($ls != $nil) {
         $cnt++;
      }
      $ls = $ls->[1];
   };
   return $cnt;
};

sub ldisp {
   my ($ls)=@_;
   my $hd = $ls->[0];
   my $tl = $ls->[1];
   print "(";
   while ($hd) {
      print $hd . " ";
      $hd = $tl->[0];
      $tl = $tl->[1];
   };
   print ")<br>\n";
};

1;
